// MethodPointersDlg.h : header file
//

#if !defined(AFX_METHODPOINTERSDLG_H__67CE375C_BEB6_11D2_A18B_00609784F50B__INCLUDED_)
#define AFX_METHODPOINTERSDLG_H__67CE375C_BEB6_11D2_A18B_00609784F50B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AverageObject.h"
#include "SumObject.h"
#include "MethodPtr.h"
/////////////////////////////////////////////////////////////////////////////
// CMethodPointersDlg dialog

#define AVERAGEMETHOD(m) METHOD(AVERAGERETURNTYPE, CAverageObject, m)
#define SUMMETHOD(m) METHOD(SUMRETURNTYPE, CSumObject, m)
#define CMethodPtrBaseint CMethodPtrBase<int>

class CMethodPointersDlg : public CDialog
{
// Construction
public:
	CMethodPointersDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMethodPointersDlg)
	enum { IDD = IDD_METHODPOINTERS_DIALOG };
	int		m_nReturn;
	int		m_nF2A1;
	int		m_nF2A2;
	int		m_nF3A1;
	int		m_nF3A2;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMethodPointersDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMethodPointersDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCallSum();
	afx_msg void OnCallAverage();
	afx_msg void OnFunc1();
	afx_msg void OnFunc2();
	afx_msg void OnFunc3();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	CMethodPtr<CAverageObject, int> m_AverageMethodPtr;  // The average class
	CMethodPtr<CSumObject, int> m_SumMethodPtr;  // The sum class

	CAverageObject m_AverageObject;
	CSumObject m_SumObject; 

	int m_nFunc;  // which function is selected

	void CallTheMethod( CMethodPtrBaseint* pMethodPtrBase );
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_METHODPOINTERSDLG_H__67CE375C_BEB6_11D2_A18B_00609784F50B__INCLUDED_)
